/**
 * What the kobold did in the deepwoods.
 */
function DeepwoodsShared() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.tentaclePlant = new TentaclePlantShared();

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Loads this object from a type-stripped version thereof.
     * @param {Shared-stripped} shared A Shared object, stripped of private members and all functions.
     */
    this.load = function (shared) {
        if (!shared) {
            that.load(new DeepwoodsShared());
            return;
        }
        that.tentaclePlant.load(shared.tentaclePlant);
    };
}

