/**
 * What the kobold did during the second noon of enslavement.
 */
function EnslavementNoonTwoShared() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.blackmailed = false; // Whether or not the kobold was blackmailed with the mouth gag (no recruitment, threat of violence, no protection from the human).
    this.makeUpOffer = false; // Whether or not the kobold was given the make up offer (no recruitment, threat of violence if it doesn't cooperate, human goes easy on it).
    this.simpleOffer = false; // Whether or not the kobold was given the simple offer (recruitment, no violence, no human).
    this.insulted = false; // Whether or not the kobold insulted Fenrir.
    this.attacked = false; // Whether or not the kobold attempted to attack Fenrir.
    this.kissedBalls = false; // Whether or not the kobold ended up kissing the wolf's balls. If true, the offer was accepted.
    this.kissedBallsEager = false; // Whether or not the kobold eagerly kissed the wolf's balls. If true, the offer was accepted.

    this.gagged = false; // Whether or not the kobold was gagged by the wolf.
    this.gagOpened = false; // Whether or not the kobold opened its mouth for the wolf's gag.

    this.badRefuse = false; // Whether or not the kobold chose to refuse to bathe while being a bad kobold, causing Fenrir to nearly attack the kobold.
    this.goodRefuse = false; // Whether or not the kobold chose to refuse to bathe while being a good kobold, causing Fenrir to get chewed out by the caravan master.
    this.badDrink = false; // Whether or not the kobold drank from the trough while being a bad kobold.
    this.goodDrink = false; // Whether or not the kobold drank from the trough while being a good kobold.
    this.badBathe = false; // Whether or not the kobold chose to bathe while being a bad kobold, causing Fenrir to get chewed out by the caravan master.
    this.goodBathe = false; // Whether or not the kobold chose to bathe while being a good kobold, causing Fenrir to leave the kobold to bathe alone.

    this.injected = false; // Whether or not the kobold was injected by the wolf.
    this.tookMPlus = false; // Whether or not the kobold took Mplus (regardless of injected or not).
    this.tookFemPlus = false; // Whether or not the kobold took FemPlus (regardless of injected or not).

    this.stageSmiled = false; // Whether or not the kobold smiled on stage.
    this.stagePosed = false; // Whether or not the koobld posed on stage.

    this.boughtBySeki = false; // Whether or not the kobold ended up being bought by Seki.

    this.complianceRating = 0; // Compliance rating for noon two. A number between one and ten signifying how well the kobold behaved.

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Adds the passed number to the current compliance rating.
     * @param {integer} toAdd How much to add (positive) or subtract (negative).
     */
    this.alterComplianceRating = function (toAdd) {
        that.complianceRating = that.complianceRating + toAdd;
    };

    /**
     * Loads this object from a type-stripped version thereof.
     * @param {Shared-stripped} shared A shared object, stripped of private members and all functions.
     */
    this.load = function (shared) {
        if (!shared) {
            that.load(new EnslavementNoonTwoShared());
            return;
        }
        that.blackmailed = shared.blackmailed || false;
        that.makeUpOffer = shared.makeUpOffer || false;
        that.simpleOffer = shared.simpleOffer || false;
        that.insulted = shared.insulted || false;
        that.attacked = shared.attacked || false;
        that.kissedBalls = shared.kissedBalls || false;
        that.kissedBallsEager = shared.kissedBallsEager || false;

        that.badRefuse = shared.badRefuse || false;
        that.goodRefuse = shared.goodRefuse || false;
        that.badDrink = shared.badDrink || false;
        that.goodDrink = shared.goodDrink || false;
        that.badBathe = shared.badBathe || false;
        that.goodBathe = shared.goodBathe || false;

        that.gagged = shared.gagged || false;
        that.gagOpened = shared.gagOpened || false;

        that.injected = shared.injected || false;
        that.tookMPlus = shared.tookMPlus || false;
        that.tookFemPlus = shared.tookFemPlus || false;

        that.stageSmiled = shared.stageSmiled || false;
        that.stagePosed = shared.stagePosed || false;
        that.boughtBySeki = shared.boughtBySeki || false;

        that.complianceRating = shared.complianceRating || 0;
    };
}

