/**
 * What the kobold did during the second night of Varanar.
 */
function NightTwoShared() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.arrivalEnum = {
        REGULAR: 1,
        RIVER: 2
    };
    this.arrival = that.arrivalEnum.REGULAR;
    this.alleyAttack = false;
    this.alleyPiss = false;
    this.beatUp = false;
    this.pissSlut = false;
    this.fuckSlut = false;
    this.fetishSlut = false;
    this.fought = false;
    this.buttKiss = false;
    this.flaccidOral = false;
    this.forced = false;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Loads this object from a type-stripped version thereof.
     * @param {NightTwoShared-stripped} nightTwo A NightTwoShared object, stripped of private members and all functions.
     */
    this.load = function (nightTwo) {
        if (!nightTwo) {
            that.load(new NightTwoShared());
            return;
        }
        that.arrival = nightTwo.arrival || that.arrivalEnum.REGULAR;
        that.alleyAttack = nightTwo.alleyAttack || false;
        that.alleyPiss = nightTwo.alleyPiss || false;
        that.beatUp = nightTwo.beatUp || false;
        that.pissSlut = nightTwo.pissSlut || false;
        that.fuckSlut = nightTwo.fuckSlut || false;
        that.fetishSlut = nightTwo.fetishSlut || false;
        that.fought = nightTwo.fought || false;
        that.buttKiss = nightTwo.buttKiss || false;
        that.flaccidOral = nightTwo.flaccidOral || false;
        that.flaccidOral = nightTwo.forced || false;
    };
}

