/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidGirlfriendFrame(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidGirlfriendJealousChoice.FRAME;
    var reqController = ctrl.jealous;
    var subController = ctrl.frame;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = new FarmerMaidGirlfriendUsurp(ctrl);
    var secondNext = new FarmerMaidGirlfriendCapture(ctrl);

    var firstChoice = FarmerMaidGirlfriendFrameChoice.USURP;
    var secondChoice = FarmerMaidGirlfriendFrameChoice.CAPTURE;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            You need to get rid of Falco's girlfriend somehow.
                            With the way she's been acting lately,
                            you wouldn't be surprised if she started [b]nagging[/b] her boyfriend to [b]kick you out[/b].
                            And that would [b]ruin[/b] your chances with him.
                            You can't have that.
                            You need to frame her, somehow.
                            But, besides being a [b]lazy whore[/b], she doesn't really do anything [i]wrong[/i].
                            Hmph.
                        [/p]
                        [p]
                            The next time the woman leaves the house, you sneak out after her.
                            Making sure you aren't seen by anyone, you trail her as she makes her way to the other side of the hamlet.
                            This place sure has gotten big since the start of your enslavement.
                            You follow her all the way to a single-story home, on the very edge of town.
                            She knocks on the door, and a few moments later, a big and burly,
                            scantily-clad, brown-furred canine stud invites her in.
                        [/p]
                        [p]
                            The sounds of intense, raw [b]breeding[/b] echo from the building.
                            The human moans like the rabid [b]slut[/b] that she is,
                            while her doggy lover knot-fucks the ever-loving shit out of her.
                            Heh.
                            You always called her a [b]bitch[/b].
                            She's a [i]clever[/i] bitch, though.
                            By doing this [b]here[/b], and not at home,
                            she doesn't really leave any [i]evidence[/i] behind.
                            You doubt Falco would take your word over hers,
                            and he's too busy working the farm to join you in [i]playing detective[/i].
                        [/p]
                        [p]
                            Looks like you're going to have to [i]cheat[/i] a little yourself.
                            All is fair in love and war, right?
                            Through an open window and a bedroom door carelessly left ajar,
                            you witness their carnal [b]mating[/b].
                            You wait until the canine's finished pumping load after load of spunk into his human fucktoy.
                            Once they're all tuckered out,
                            she redresses, but he stays naked as he escorts her back to the front door.
                            There's your chance.
                        [/p]
                        [p]
                            You sneak in through the open window, bolt to the bedroom,
                            [b]snatch[/b] his loincloth from the bed, and vanish before anyone even knew you were there.
                            Phase one, completed.
                            You head back home, arriving before your [i]mistress[/i] does, and pretend to be working.
                            You hide the stolen loincloth in a dresser.
                            She's completely oblivious that you are aware of her secret.
                            Just as planned.
                        [/p]
                        [p]
                            The next day, she goes to fuck her secret lover again.
                            This time, you don't follow.
                            You head up to the bedroom that Romeo and Juliet used to sleep in,
                            ruffle the sheets of their long-unused bed, and toss the male garment ontop.
                            At noon, Falco comes home to have a snack.
                            You tell him that his girlfriend brought some guy you didn't know back here.
                            They went up to his parents' old room, and while you don't want to make any accusations,
                            you [i]think[/i] they had sex there.
                            Afterwards, the two walked out the door once more, holding hands.
                        [/p]
                        [p]
                            Romeo is shook.
                            He tells you that you better not be lying.
                            You assure him that you're not.
                            You didn't really [i]want[/i] to tell him,
                            but you'd rather break his heart than have him live as a [b]cuckold[/b] for the rest of his life.
                        [/p]
                        [p]
                            Still, he doesn't believe you.
                            You lead him up the stairs, and into the bedroom.
                            The evidence you planted is still there.
                            His beady bird eyes go wide.
                            He takes a seat on the edge of the bed, unable to process his entire life tumbling down.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Usurp her</button>`;

        var tooltip = global.parser.parse(`Boot her out. Take her place. Become the girlfriend.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 200px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Capture her</button>`;

        var tooltip = global.parser.parse(`Keep her around. Make her clean for you.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var FarmerMaidGirlfriendFrameChoice = {
    USURP: 1,
    CAPTURE: 2
};
