/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidGirlfriendJealous(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidGirlfriendChoice.JEALOUS;
    var reqController = ctrl.girlfriend;
    var subController = ctrl.jealous;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = new FarmerMaidGirlfriendFrame(ctrl);
    var secondNext = new FarmerMaidGirlfriendKill(ctrl);

    var firstChoice = FarmerMaidGirlfriendJealousChoice.FRAME;
    var secondChoice = FarmerMaidGirlfriendJealousChoice.KILL;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Falco's girlfriend is a [b]bitch[/b].
                            Whenever she's home, she [b]constantly[/b] bosses you around.
                            She makes you fetch her drinks, she forces you to clean and file down her nails,
                            she gets you to feed her grapes so she doesn't have to tire her arms out,
                            and she even uses your back as a [b]footrest[/b] more than once.
                            If you don't comply to her wishes, she denies you your daily morsel of food.
                        [/p]
                        [p]
                            She acts like she's the [b]queen[/b] of the humans, or something.
                            But all she rules is this hovel, her boyfriend, and sadly enough, [b]you[/b].
                            Since he's started working the farm, Falco's attitude has improved a lot.
                            He's slowly starting to [b]respect[/b] you, and all of the work that you do.
                            It feels nice, to have someone [b]congratulate[/b] you,
                            and telling you that you did a [b]good job[/b].
                            You're slowly starting to grow closer to your new master.
                        [/p]
                        [p]
                            The new woman of the house, however, continues to act like a complete [b]cunt[/b].
                            She has you re-do your sweeping because you [i]missed a spot[/i],
                            she viciously criticizes you even if you abide by her wishes,
                            and she even talks bad to Falco about you,
                            sometimes going as far as telling [b]lies[/b] to make you seem worse.
                        [/p]
                        [p]
                            The worst part of all of this, is that at the end of the day,
                            it's [b]her[/b] that gets to sleep in bed with the bird, and not you.
                            You're not even allowed to use his parents' now-empty room,
                            thanks to her objections.
                            It's not fair.
                            She does [b]nothing[/b] for him, and he loves her to [b]death[/b].
                            You work your ass off, and some rare thanks are all you get in return.
                        [/p]
                        [p]
                            You find yourself creeping around their room at night,
                            spying on them [b]fucking[/b] through the cracks in the wooden door.
                            One night, he pounds her brains out in missionary position,
                            the next day she rides him like the lusty [b]whore[/b] that she is,
                            a week later he fucks the bitch doggy-style.
                            Every time, they both end their intense lovemaking bouts completely euophoric.
                            You do all the work around here.
                            That should be [b]you[/b] the bird is making happy, and not [b]her[/b].
                        [/p]
                        [p]
                            While your unrequited attraction to Falco grows with every passing day,
                            so too does your [b]detest[/b] for his girlfriend.
                            During meals, you affectionately sit on the ground next to him,
                            occasionally nuzzling against or hugging his feathery leg.
                            He laughingly dismisses your behavior, treating you like a [i]dog[/i] begging for scraps.
                            Meanwhile, you cast hateful glares at the human, and hiss at her whenever she looks at you the wrong way.
                            All outside of your bird-crush's view, of course.
                        [/p]
                        [p]
                            A few months after Romeo and Juliet have left,
                            the human girl starts to leave the house during the day.
                            You don't know what she heads off to do, and you don't really [i]care[/i].
                            You're glad that you finally get a few short periods to yourself.
                            Not only because you wanted the privacy, but also because this allows you to start [b]planning[/b] and [b]scheming[/b].
                            You have to do something about her.
                            But what?
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Frame her</button>`;

        var tooltip = global.parser.parse(`Make it seem like she's sleeping around. Once there's trouble in paradise, you can make your move.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Kill her</button>`;

        var tooltip = global.parser.parse(`You don't think the bird's a necrophile. He'll be all yours once she's out of the picture.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var FarmerMaidGirlfriendJealousChoice = {
    FRAME: 1,
    KILL: 2
};
