/**
 * Proposition section of Enslavement, Noon Two.
 * @param {SlaveNoonTwoController} controller The Enslavement, Noon Two controller.
 */
function SlaveNoonTwoBadEager(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = SlaveNoonTwoOfferChoice.EAGER;
    var reqController = ctrl.blackmail;
    var subController = ctrl.preGag;
    var changeController = ctrl.badEager;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.notGagged;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.enslavement.noonTwo.kissedBallsEager = true;
        var toReturn = `[p]
                            A million thoughts run through your head.
                            If you decline, there'll be [b]hell[/b] to pay.
                            But you are [b]very[/b] certain that [i]if[/i] you do this,
                            it'll undoubtedly lead to him asking [b]more[/b] and [b]more[/b] of you.
                            If you give in now, he'll keep pushing and pushing until you're his personal [b]concubine[/b] or something.
                            And for some reason, that kind of [i]arouses[/i] you.
                        [/p]
                        [p]
                            You never had a problem with Fenrir.
                            It was the caravan master who was acting like a real [b]prick[/b] last night.
                            While you don't want to get [b]killed[/b] by his [i]Furskin Mountain-Crew[/i],
                            as the canine threatened might happen,
                            you figure life with them could still turn out to be quite [i]nice[/i],
                            as long you serve them [b]properly[/b].
                            Surely they'll have no reason to hurt you if you obey their every wish, right?
                        [/p]
                        [p]
                            Becoming the big wolf's [b]plaything[/b] is an alluring prospect by itself.
                            Combined with the equally enticing big, furred orbs swinging underneath his plump sheath,
                            Fenrir's offer is practically [b]irresistible[/b] to you.
                            How could [b]anyone[/b] be faced with such a [b]hunk[/b] of a man,
                            and [b]not[/b] want to submit to him completely?
                            Should you end up not being [i]bought[/i],
                            then you'll get to live a comfortable life with your new lupine [i]master[/i],
                            hopefully far away from the chubby human that accosted you yesterday.
                        [/p]
                        [p]
                            Noticing the bandit growing impatient,
                            you lustily lick your lips and begin to inch your face closer to his balls.
                            The strong scent of canine masculinity intensifies,
                            male pheromones [b]wafting[/b] liberally from Fenrir's loins,
                            [b]clogging[/b] your nostrils, [b]saturating[/b] every breath you take.
                            You greedily huff the olfactory nectar, savoring every lungful,
                            wishing you could keep your face buried in his balls [b]forever[/b].
                        [/p]
                        [p]
                            While your own need is rising, you aren't about to get [i]distracted[/i] by it.
                            You set out to [i]please[/i] your master, and you intend to [b]exceed[/b] his every expectation.
                            As your snout sinks into the grey fur covering the wolf's sack,
                            you pucker your lips, and eagerly begin to plant kiss after kiss atop of his nuts.
                            Taking one of his balls into your mouth slightly, you gently suckle on it, just a little.
                            He groans in delight, his tense, authorative stand visibly relaxing.
                            [b]Excellent[/b].
                        [/p]
                        [p]
                            With Fenrir starting to mellow out, you up the intensity of your loving [b]admiration[/b].
                            Your tongue snakes out of your muzzle, your rampant kissing interrupted by occasional [b]licks[/b].
                            Before long, you find yourself outright [b]lapping[/b] along the coarse surface of the canine's sack,
                            wetting his fur with your saliva, enjoying the salty,
                            undeniably [b]masculine[/b] flavour even [b]despite[/b] the dried up sweat and the small bits of dirt and grime.
                        [/p]
                        [p]
                            The wolf begins to pant, his tail wagging excitedly.
                            Slowly, but surely, you work your way upwards, towards his sheath.
                            Right as you were about to goad his member from its slumber by kissing its resting place directly,
                            Fenrir suddenly presses his palm against your forehead, softly pushing you away.
                        [/p]
                        [p]
                            "[color=gblue]That's enough for now, you little [b]cocktease[/b].
                            Quite the apology.
                            If you were trying to impress me, it's a job well done.
                            Continue to act like that, and I might need to consider buying you myself,
                            to make sure nobody else gets to run off with that lovely muzzle of yours.[/color]"
                            Your captor takes a deep breath, seemingly washing the impure thoughts from his mind.
                            "[color=gblue]There'll be plenty of time for me to fuck your face later.
                            And since you like my balls so much,
                            you'll get to [b]worship[/b] them every single day, once you're finally [b]mine[/b].[/color]"
                            You can hardly wait.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
